HWND mRichEdit;

int GetTextLength(HWND hwnd)
{
	GETTEXTLENGTHEX gt;
	int nLen;

	gt.codepage = CP_ACP;
	
	nLen = (int)SendMessage(hwnd, EM_GETTEXTLENGTHEX, (WPARAM)&gt, 0);

	return nLen;
}

int GetLastPos(int nLine)
{
	int nLineCount = (int)SendMessage(mRichEdit, EM_GETLINECOUNT, 0, 0);

	if(nLine == nLineCount - 1)
	{
		int nTextLen = GetTextLength(mRichEdit);
		return nTextLen;
	}

	else
	{
		int nPos = (int)SendMessage(mRichEdit, EM_LINEINDEX, nLine + 1, 0);
		return (nPos - 1);
	}
}

BOOL GetTextRange(HWND hwnd, char *pszLine)
{
	TEXTRANGE tr;

	int nCurrentLine = (int)SendMessage(hwnd, EM_LINEFROMCHAR, -1, 0);

	tr.chrg.cpMin = (int)SendMessage(hwnd, EM_LINEINDEX, nCurrentLine, 0);
	tr.chrg.cpMax = GetLastPos(nCurrentLine);
	tr.lpstrText = pszLine;

	if(tr.chrg.cpMin == tr.chrg.cpMax)
		return FALSE;
	else
		SendMessage(hwnd, EM_GETTEXTRANGE, 0, (LPARAM)&tr);

	return TRUE;
}
