#include <windows.h>
#include <richedit.h>
#include <commctrl.h>

#include "mKeywords.h"
#include "CPos.h"

#define mFunc(x)			int WINAPI x(HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
#define mReturn(x)			lstrcpy(data, x);

typedef struct {
	DWORD mVersion;
	HWND mHwnd;
	BOOL mKeep;
} LOADINFO;

HHOOK mHook;
WNDPROC mOrigProc;

HWND mEditor;

HWND mTip;
char *szTipText;

BOOL bHooked = FALSE;
int nCalls = 1;

DWORD dVersion;

int PosTooltip(POINT *pt)
{
	// set tooltip position depending on mIRC version
	if(HIWORD(dVersion) == 31)
	{
		pt->x = 12;
		pt->y = 84;
	}
	else
	{
		pt->x = 22;
		pt->y = 113;
	}

	return 0;
}

void EditorCleanup(void)
{
	UnhookWindowsHookEx(mHook);
	SetWindowLong(mRichEdit, GWL_WNDPROC, (LONG)mOrigProc);

	nCalls = 1;
	bHooked = FALSE;
}

void CreateTooltip(char *szText)
{
	TOOLINFO ti;

	memset(&ti, 0, sizeof(TOOLINFO));

	ti.cbSize	= sizeof(TOOLINFO);
	ti.hwnd		= mRichEdit;
	ti.hinst	= NULL;
	ti.lpszText	= szTipText;

	mTip = CreateWindowEx(WS_EX_TRANSPARENT, TOOLTIPS_CLASS, NULL, 
		TTS_NOPREFIX, 
		0, 0, 0, 0, 
		mRichEdit, NULL, GetModuleHandle(NULL), NULL);

	if(IsWindow(mTip))
	{
		POINT ptCaret;
		POINT ptVersion;
		RECT rc;

		int nLeft;
		int nTop;

		SendMessage(mTip, TTM_ADDTOOL, 0, (LPARAM)&ti);
		SendMessage(mTip, TTM_TRACKACTIVATE, TRUE, (LPARAM)&ti);

		GetCaretPos(&ptCaret);

		GetWindowRect(mEditor, &rc);

		PosTooltip(&ptVersion);

		nLeft	= rc.left + ptCaret.x + ptVersion.x;
		nTop	= rc.top + ptCaret.y + ptVersion.y;

		SetWindowPos(mTip, NULL, nLeft, nTop, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE);
	}
}

BOOL IsKeyword(char *szMatch)
{
	int i;
	char szWord[60];

	for(i=0;i<KEYWORDS;++i)
	{
		lstrcpy(szWord, Keywords[i]);

		strtok(szWord, "(");

		if(strcmp(szMatch, szWord) == 0)
		{
			szTipText = Keywords[i];
			return TRUE;
		}
	}

	return FALSE;
}